<%@ Language=VBScript %>
<%
'*************************************************************************
' DO NOT MODIFY THIS SCRIPT IF YOU WANT UPDATES TO WORK!
' Function : Displays a list of products that match a given criteria...
'          : - Matches search criteria
'          : - Matches a category
'          : - Matches "specials" on flagged products
'          : If a category is supplied which has sub categories, the
'          : script will display a summary of categories instead of the
'          : product list.
' Product  : Shopping Tree Store Frontend
' Version  : 3.3
' Modified : January 2005
' Copyright: Copyright (C) 2004 Shopping Tree.Com 
'            See "license.txt" for this product for details regarding 
'            licensing, usage, disclaimers, distribution and general 
'            copyright requirements. If you don't have a copy of this 
'            file, you may request one at webmaster@ShoppingTree.com
'*************************************************************************
'   Date							Description
' 10/23/05	Added user exit 
' 10/28/05  Modified expandCategory to use different languages
' 10/28/05	Add script delimiters for prodList user exit
' 01/02/06	Category heading text was not reading from langCategory
' 02/20/06	Fixed problem with Supplier filters not working correctly.
' 04/18/06	Added branding support
' 05/31/06  Corrected brand searching functionality
'*************************************************************************
Option explicit
Response.Buffer = true
%>
<!--#include file="_INCconfig_.asp"-->
<!--#include file="_INCappDBConn_.asp"-->
<!--#include file="_INCappFunctions_.asp"-->  
<%
'Work Fields
dim I
dim totalRecs
dim totalPages
dim count
dim curPage
dim catPos
dim catLst
dim listHeading
dim special
dim strSearch, strSearchType, strSearchMax, strSearchMin, strSearchCat, strSearchBrand
dim sortField
dim queryStr
dim subCount, maxCol, cellWidth
dim searchArr
dim tmpSQL1, tmpSQL2, tmpSQL3, tmpSQL4
dim wishlist
dim favorites
dim idSF
dim brandName

'Categories
dim IDCategory
dim categoryDesc
dim IDParentCategory
dim categoryHTML
dim categoryHTMLLong
dim sortOrder

'Product
dim IDProduct
dim SKU
dim Description
dim DescriptionLong
dim Price
dim Details
dim listPrice
dim smallImageURL
dim imageURL
dim Stock
dim fileName
dim noShipCharge
dim handlingFee
dim wholesaleprice
dim msrp
dim map
dim freight
dim estimatedship
dim brand
dim refurbished

'Database
dim mySQL
dim conntemp
dim rstemp
dim rstemp2
dim recordArr

'Session
dim idOrder
dim idCust

'*************************************************************************

'Open Database Connection
call openDb()

'Store Configuration
if loadConfig() = false then
	call errorDB(LangText("ErrConfig",""),"")
end if

'Get/Set Cart/Order Session
idOrder = sessionCart()

'Get/Set Customer Session
idCust  = sessionCust()

idSF = request.cookies(storeID & "idSF")
if len(idSF) = 0 or IsNull(idSF) then
	'Create empty favorites record
		set rsTemp = openRSopen("CustSF",adUseServer,adOpenKeySet,adLockOptimistic,adCmdTable,0)
		rsTemp.AddNew
		rsTemp("dateCreated")	= currDateTime("DT",timeOffSet)
		rsTemp("dateCreatedInt")= dateInt(currDateTime("DT",timeOffSet))
		rsTemp.update 
		response.cookies(storeID & "idSF") = rsTemp("idSF")
		response.cookies(storeID & "idSF").expires = dateAdd("d",30,now())
		response.cookies(storeID & "idSF").path = "/"
		idSF = rsTemp("idSF")
		call closeRS(rsTemp)
end if


'Get/Set Affilate ID
call getIdAffiliate(Request.QueryString("idAff"))

'---------------------------------
' PARMS - Search
'---------------------------------
strSearch     = Request("strSearch")
strSearchType = Request("strSearchType")
strSearchMin  = Request("strSearchMin")
strSearchMax  = Request("strSearchMax")
strSearchCat  = Request("strSearchCat")
strSearchBrand =Request("strSearchBrand")
if len(strSearch & strSearchMin & strSearchMax & strSearchCat & strSearchBrand) > 0 then

	'Get rid of malicious HTML
	strSearch     = validHTML(strSearch)
	strSearchType = validHTML(strSearchType)
	strSearchMin  = validHTML(strSearchMin)
	strSearchMax  = validHTML(strSearchMax)
	strSearchCat  = validHTML(strSearchCat)
	strSearchBrand= validHTML(strSearchBrand)
	
	'Get rid of multiple spaces in keywords
	do until instr(strSearch,"  ") = 0			
		strSearch = replace(strSearch,"  "," ")
	loop
	
	'After all this string manipulation, check the search is still valid
	if len(strSearch & strSearchMin & strSearchMax & strSearchCat & strSearchBrand) = 0 then
		Response.Clear
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrInvSearch",""))
	end if
	
	'Assign default values
	if  strSearchType <> "AND" _
	and strSearchType <> "OR"  _
	and strSearchType <> "PHR" then
		strSearchType = "OR"
	end if
	
	if not(isNumeric(strSearchMin)) then
		strSearchMin = 0
	else
		strSearchMin = CDbl(strSearchMin)
	end if
	
	if not(isNumeric(strSearchMax)) then
		strSearchMax = 0
	else
		strSearchMax = CDbl(strSearchMax)
	end if
	
	if not(isNumeric(strSearchCat)) then
		strSearchCat = 0
	else
		strSearchCat = CInt(strSearchCat)
	end if
	
	if len(strSearchBrand) = 0 then
		strSearchBrand = ""
	end if
	
	
end if

'---------------------------------
' PARMS - Specials
'---------------------------------
special = Request.QueryString("special")
if len(special) > 0 and special <> "Y" then
	special = "N"
end if

wishlist = Request.QueryString("wishlist")
if len(wishlist) > 0 and wishlist <> "Y" then
	wishlist = "N"
end if

favorites = Request.QueryString("favorites")
if len(favorites) > 0 and favorites <> "Y" then
	favorites = "N"
end if

brandname = Request.QueryString("brand")
if len(brandname) = 0 then 
	brandname = ""
end if


'---------------------------------
' PARMS - Categories
'---------------------------------
idCategory = Request.QueryString("idCategory")
if len(idCategory) > 0 then

	'Validate that Category is numeric
	if not IsNumeric(idCategory) then
		Response.Clear
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrInvCategory",""))
	end if

	'Validate that Category exists in DB
	mySQL = "SELECT idCategory, categoryDesc, categoryHTMLLong " _
		  & "FROM   categories " _
		  & "WHERE  idCategory = " & validSQL(idCategory,"I")
	set rsTemp = openRSexecute(mySQL)
	if rsTemp.eof then
		'Give error
		Response.Clear
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrInvCategory",""))
	else
		'Get Category HTML (Long)
		categoryHTMLLong = trim(rsTemp("categoryHTMLLong"))
		categoryDesc = trim(rsTemp("categoryDesc"))
	end if
	call closeRS(rsTemp)

end if

'---------------------------------
' PARMS - Validate
'---------------------------------
if  len(strSearch & strSearchMin & strSearchMax & strSearchCat & strSearchBrand) = 0 _
and len(special) = 0 _
and len(idCategory) = 0 _
and len(wishlist) = 0 _
and len(favorites) = 0 _
and len(brandname) = 0  then
	'If no valid parms were passed, or the script was called without
	'parms, then display the entire category tree.
	mySQL = "SELECT idCategory, categoryDesc " _
		  & "FROM   categories " _
		  & "WHERE  IdParentCategory = 0"
	set rsTemp = openRSexecute(mySQL)
	if rsTemp.eof then
		Response.Clear
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrInvCategory","") & " / " & LangText("ErrInvSearch",""))
	else
		IDCategory = rsTemp("idCategory")
		categoryDesc = rsTemp("categoryDesc")
	end if
	call closeRS(rsTemp)
end if

%>
<!--#include file="../UserMods/_INCtemplate_.asp"--> 
<%

'Close Database Connection
call closeDb()

'*************************************************************************
'Main Shopping Cart Display Area
'*************************************************************************
sub cartMain()

	'Display message if any
	if len(request.querystring("msg")) > 0 then
		response.write "<p align=center><font size=""3"" color=""#ff0000"">" & Request.QueryString("Msg") & "</font></p><br>"
	end if
	
	'SEARCH
	if len(strSearch & strSearchMin & strSearchMax & strSearchCat) > 0 then
		listHeading = "<b>" & LangText("GenSearchFor","") & " : </b> " & strSearch & " [" & strSearchType & "," & strSearchMin & "," & strSearchMax & "," & strSearchCat & "," & strSearchBrand & "] "
		queryStr	= "strSearch=" & Server.UrlEncode(strSearch) & "&strSearchType=" & Server.UrlEncode(strSearchType) & "&strSearchMin=" & Server.UrlEncode(strSearchMin) & "&strSearchMax=" & Server.UrlEncode(strSearchMax) & "&strSearchCat=" & Server.UrlEncode(strSearchCat) & "&strSearchBrand=" & Server.UrlEncode(strSearchBrand)
		call displayItems("search")
	else

		'SPECIALS
		if len(special) > 0 then
			listHeading = "<b>" & LangText("GenSpecials","") & "</b>"
			queryStr	= "special=Y"
			call displayItems("special")
			
		elseif len(favorites) > 0 then
			' favorites
			response.write "<b>" & LangText("FavoritesList","Favorite Item List") & "</b>"
			queryStr = "favorites=Y"
			call displayItems("favorites")
		elseif len(brandname) > 0 then
			response.write "<b>" & LangText("BrandNames","Brand Name") & ": " & brandname & "</b>"
			queryStr="brand=" & brandname
			call displayItems("brandname")
			
		elseif len(wishlist) > 0 then
		'wishlist
			call displayItems("wishlist")
			
		else
			'CATEGORIES
			'Determine category tree position (eg: You are at : cat1 > cat2)
			catPos = getCategoryPos(IDCategory,"","Y")
			
			'Expand the Category tree from the supplied category onward
			catLst = expandCategory(IDCategory,"")
			
			'Display Category Tree position
			listHeading = "<b>" & LangText("GenYouAreAt","") & " : </b>" & catPos
			
			'Display list of products that match category
			if len(trim(catLst)) = 0 then
				queryStr = "idcategory=" & IDCategory
				call displayItems("list")

			'Display Category Tree
			else
				call displayCategory()
			end if
		end if
	end if
end sub

'*************************************************************************
'Expand Categories tree from given category (recursive). Will also 
'display the number of products in each sub category.
'*************************************************************************
function expandCategory(IDCategory,tempStr)

	dim mySQL, rsTemp, catArr, row
	
	'Get Sub-Categories
	mySQL = "SELECT idCategory, categoryDesc,categoryHTML," _
		  & "      (SELECT COUNT(*) " _
		  & "       FROM   products, categories_products " _
		  & "       WHERE  products.idProduct = categories_products.idProduct " _
		  & "       AND    categories_products.idCategory = categories.idCategory " _ 
		  & "       AND    active = -1) " _
		  & "       AS     prodCount " _
		  & "FROM   categories " _
		  & "WHERE  idParentcategory = " & validSQL(idCategory,"I") & " " _
		  & "ORDER BY sortOrder, categoryDesc "
	set rsTemp = openRSexecute(mySQL)
	if not rsTemp.EOF then
	
		'Use getRows() to reduce DB resource requirements. This is a 
		'little more difficult to work with, but makes the queries 
		'much faster. After populating the array, the values are :

		'- catArr(0,row) = idCategory
		'- catArr(1,row) = categoryDesc
		'- catArr(2,row) = categoryHTML
		'- catArr(3,row) = prodCount

		catArr = rsTemp.getRows()
		
	end if
	call closeRS(rsTemp)
	
	'Show Sub-Categories
	if isArray(catArr) then
		tempStr = tempStr & "<ul class=CPcatDescList>"
		for row = 0 to UBound(catArr,2)
			tempStr = tempStr & "<li style=""MARGIN-BOTTOM:5px"">"
			tempStr = tempStr & langCategory(catArr(0,row),"categoryHTML",catArr(2,row))
			
			'Multi Level Display 
			if categoryLayout = 0 then
				if catArr(3,row) = 0 then
					tempStr = tempStr & "<span class=CPcatDesc>" & langCategory(catArr(0,row),"categoryDesc",catArr(1,row)) & "</span>"
				else
					tempStr = tempStr & "<span class=CPcatDescProd><a href=""prodList.asp?idCategory=" & catArr(0,row) & """>" & langCategory(catArr(0,row),"categoryDesc",catArr(1,row)) & "</a> (" & catArr(3,row) & ")</span>"
				end if
				tempStr = tempStr & "</li>" & vbCrLf
				tempStr = expandCategory(catArr(0,row),tempStr)
			
			'Single Level Display
			else		
				tempStr = tempStr & "<span class=CPcatDescProd><a href=""prodList.asp?idCategory=" & catArr(0,row) & """>" & langCategory(catArr(0,row),"categoryDesc",catArr(1,row)) & "</a></span>"
				tempStr = tempStr & "</li>" & vbCrLf
			end if
						
		next
		tempStr = tempStr & "</ul>"
	end if	
	
	expandCategory = tempStr
end function
'*************************************************************************
'Display Category Tree
'*************************************************************************
sub displayCategory()
%>
	<table width="100%" border="0" cellspacing="0" cellpadding="2">
		<tr><td align=left valign=middle class="CPpageHead">
			<%=listHeading%><br>
		</td></tr>
	</table>
	
	<img src="../UserMods/misc_cleardot.gif" height=3 width=1><br>

	<table width="100%" border="0" cellspacing="4" cellpadding="4">
		<tr>
			<td align=left valign=top>
				<%=catLst%>	
			</td>
		</tr>
	</table>
<%
end sub
'*************************************************************************
'Display list of products for category
'*************************************************************************
sub displayItems(listAction)
	'Initialize variables
	count = 0
	subCount = 0
	if listViewLayout = 2 then '2 Column View
		maxCol = 2
		cellWidth = 50
	end if
	if listViewLayout = 3 then '3 Column View
		maxCol = 3
		cellWidth = 33
	end if
	if listViewLayout = 4 then '4 Column View
		maxCol = 4
		cellWidth = 25
	end if

	'Determine sort order
	sortField = lcase(trim(Request.QueryString("sortField")))
	if  sortField <> "description" _
	and sortField <> "price" _
	and sortField <> "sortorder" _
	and sortField <> "sku" then
		sortField  = pListSortOrder
	end if
	
	'Determine page number
	curPage = Request.QueryString("curPage")
	if len(curPage) = 0 or not isNumeric(curPage) then
		curPage = 1
	else
		curPage = CLng(curPage)
	end if

	'Create SQL statement
	select case listAction
	
		'SEARCH
		case "search"
		
			'SQL - General
			mySQL = "SELECT a.idProduct,a.SKU,a.description," _
				  & "       a.descriptionLong,a.listPrice,a.Price," _
				  & "       a.SmallImageUrl,a.Stock,a.fileName," _
				  & "       a.noShipCharge, a.handlingFee " _
				  & "FROM   products a " _
				  & "WHERE  a.active = -1 "

			'SQL - Minimum Price
			if strSearchMin <> 0 then
				mySQL = mySQL & "AND a.Price >= " & validSQL(strSearchMin,"D") & " "
			end if
			
			'SQL - Maximum Price
			if strSearchMax <> 0 then
				mySQL = mySQL & "AND a.Price <= " & validSQL(strSearchMax,"D") & " "
			end if
			
			if len(strSearchBrand) <> 0  then
				mySQL = mySQL & "AND a.brand = '" & validSQL(strSearchBrand,"A") & "' "
			end if
			
			'SQL - Category
			if strSearchCat <> 0 then
				mySQL = mySQL _
					  & "AND EXISTS ("_ 
					  & "    SELECT b.idCategory " _
					  & "    FROM   categories_products b " _
					  & "    WHERE  b.idProduct  = a.idProduct " _
					  & "    AND    b.idCategory = " & validSQL(strSearchCat,"I") & ") "
			end if

			'SQL - Keywords
			if len(strSearch) > 0 then
			
				'Create array of keywords. If we're doing a PHRase 
				'search, an array with only one position is created 
				'containing the entire search string. If an AND or 
				'an OR "keyword" search is being performed, each word 
				'is put into it's own array position.
				if  strSearchType = "PHR" then
					redim searchArr(0)
					searchArr(0) = trim(strSearch)
				else
					searchArr = split(trim(strSearch)," ")
				end if

				'Keyword search SQL
				tmpSQL1 = "(a.details LIKE "
				tmpSQL2 = "(a.description LIKE "
				tmpSQL3 = "(a.descriptionLong LIKE "
				tmpSQL4 = "(a.SKU LIKE "
				for i = 0 to Ubound(searchArr)
					if i = Ubound(searchArr) then
						tmpSQL1 = tmpSQL1 & "'%" & validSQL(searchArr(i),"A") & "%')"
						tmpSQL2 = tmpSQL2 & "'%" & validSQL(searchArr(i),"A") & "%')"
						tmpSQL3 = tmpSQL3 & "'%" & validSQL(searchArr(i),"A") & "%')"
						tmpSQL4 = tmpSQL4 & "'%" & validSQL(searchArr(i),"A") & "%')"
					else
						tmpSQL1 = tmpSQL1 & "'%" & validSQL(searchArr(i),"A") & "%' " & strSearchType & " a.details         LIKE "
						tmpSQL2 = tmpSQL2 & "'%" & validSQL(searchArr(i),"A") & "%' " & strSearchType & " a.description     LIKE "
						tmpSQL3 = tmpSQL3 & "'%" & validSQL(searchArr(i),"A") & "%' " & strSearchType & " a.descriptionLong LIKE "
						tmpSQL4 = tmpSQL4 & "'%" & validSQL(searchArr(i),"A") & "%' " & strSearchType & " a.SKU             LIKE "
					end if
				next
				
				'Put it all together
				mySQL = mySQL & "AND (" & tmpSQL1 & " OR " & tmpSQL2 & " OR " & tmpSQL3 & " OR " & tmpSQL4 & ") "
				
			end if
			
			'Sort Order
			mySQL = mySQL & "ORDER BY a." & sortField
			'------------------------------------------------------------
			
		'SPECIALS
		case "special"
		
			mySQL = "SELECT idProduct,SKU,Description,DescriptionLong," _
				  & "       ListPrice,Price,SmallImageUrl,Stock," _
				  & "       fileName,noShipCharge,handlingFee " _
			      & "FROM   products " _
			      & "WHERE  hotDeal = -1 " _
			      & "AND    active = -1 " _
			      & "ORDER BY " & sortField
	
		'favorites
		case "favorites"
			mySQL = "SELECT idProduct,SKU,Description,DescriptionLong," _
				  & "       ListPrice,Price,SmallImageUrl,Stock," _
				  & "       fileName,noShipCharge,handlingFee " _
			      & "FROM   products " _
			      & "WHERE  idProduct IN " _
			      & 	"(SELECT idProduct " _
			      &	 	"FROM favorites " _
			      &  	"WHERE idCustomer = " & idSF & ") " _
			      & "AND    active = -1 " _
			      & "ORDER BY " & sortField	
			      
		'Brand Name
		case "brandname"
			mySQL = "SELECT idProduct,SKU,Description,DescriptionLong," _
				  & "       ListPrice,Price,SmallImageUrl,Stock," _
				  & "       fileName,noShipCharge,handlingFee " _
			      & "FROM   products " _
			      & "WHERE  brand = '" & brandname & "' " _
			      & "AND    active = -1 " _
			      & "ORDER BY " & sortField	
			      
		'wishlist
		case "wishlist"
			mySQL = "SELECT idProduct,SKU,Description,DescriptionLong," _
				  & "       ListPrice,Price,SmallImageUrl,Stock," _
				  & "       fileName,noShipCharge, handlingFee " _
			      & "FROM   products " _
			      & "WHERE  hotDeal = -1 " _
			      & "AND    active = -1 " _
			      & "ORDER BY " & sortField			
			
		'CATEGORY
		case else
		
			mySQL = "SELECT a.idProduct,a.SKU,a.Description," _
				  & "       a.DescriptionLong,a.ListPrice,"_
				  & "       a.Price,a.SmallImageUrl,a.Stock," _
				  & "       a.fileName,a.noShipCharge,a.handlingfee " _
			      & "FROM   products a, categories_products b " _
			      & "WHERE  a.idProduct = b.idProduct " _
			      & "AND    b.idCategory = " & validSQL(idCategory,"I") & " " _
			      & "AND    a.active = -1 " _
			      & "ORDER BY a." & sortField
			
	end select
	'Create and Open recordset
	set rsTemp = openRSopen(mySQL,0,adOpenStatic,adLockReadOnly,adCmdText,pMaxItemsPerPage)

	'Read through recordset and display products
	if rstemp.eof then
		response.write "<br><br><b>"  & LangText("ErrNoRecFound","") & "</b><br><br>"
	else
		rstemp.MoveFirst
		rstemp.PageSize		= pMaxItemsPerPage
		totalPages 			= rstemp.PageCount
		totalRecs			= rstemp.RecordCount
		rstemp.AbsolutePage	= curPage
		
%>

		<table width="100%" border="0" cellspacing="0" cellpadding="2">
			<tr><td valign=middle class="CPpageHead">
				<%=listHeading%><br>
			</td></tr>
		</table>
		<img src="../UserMods/misc_cleardot.gif" height=4 width=1><br>
<%
		'Display Category HTML (Long)
		if len(categoryHTMLLong) > 0 then
%>
			<table width="100%" border="0" cellspacing="0" cellpadding="2">
				<tr><td><%=langCategory(idCategory,"categoryHTMLLong",categoryHTMLLong)%></td></tr>
			</table>
			<img src="../UserMods/misc_cleardot.gif" height=4 width=1><br>
<%
		end if

		'Display top page navigation and sort
%>
		<table width="100%" border="0" cellspacing="0" cellpadding="4" class="CPpageNav">
		<form name="selectPageTopForm">
			<tr>
				<td nowrap align=left valign=middle>
<%
					'Show Page Navigation if more than one page
					if totalPages > 1 then
						call pageNavigation("selectPageTop")
					else
						Response.Write "&nbsp;"
					end if
%>
				</td>
				<td nowrap align=right valign=middle>
<%
					'Show Page Sort if more than one product
					if totalRecs > 1 then
						call pageSort("sortPageTop")
					else
						Response.Write "&nbsp;"
					end if
%>
				</td>
			</tr>
		</form>
		</table>
		<img src="../UserMods/misc_cleardot.gif" height=4 width=1><br>

		<table width="100%" border="0" cellspacing="2" cellpadding="4">
<%
		'Show list of Products
		do while not rstemp.eof and count < rstemp.pageSize
	
			IDProduct		= rstemp("idProduct")
			SKU             = trim(rstemp("SKU")&"")
			if session("language") = "en" then
				Description		= trim(rstemp("description")&"")
				DescriptionLong	= trim(rstemp("descriptionLong")&"")
			else
				Description		= trim(langProduct(idProduct,"description",rstemp("description"))&"")
				DescriptionLong	= trim(langProduct(idProduct,"descriptionLong",rstemp("descriptionLong"))&"")
			end if			
			listPrice		= rstemp("listPrice")   
			Price			= rstemp("price")   
			smallImageURL	= trim(rstemp("smallImageUrl")&"")
			Stock      		= rstemp("Stock")
			fileName		= trim(rstemp("fileName")&"")
			noShipCharge	= trim(rstemp("noShipCharge")&"")
			handlingFee		= rstemp("handlingFee")
' Custom user exit to change pricing etc.
%>		
<!--#include file="../usermods/_INCprodList_.asp"-->
<%		
			' Currency Support
			listPrice = Exchange(listPrice)
			price = Exchange(price)
			handlingFee = Exchange(handlingFee)
			
			'Check if we must show Classic (0) or Extended (1) layout
			if listViewLayout = 0 or listViewLayout = 1 then
%>
				<tr>
					<td align=left valign=top>
						<%call getprodDesc()%>
						<%call getprodSKU()%><br><br>
						<%call getprodDescLong()%><br><br>
						<table border=0 cellspacing=0 cellpadding=0>
						<tr>
							<td nowrap valign=bottom width=200><%call getPricing(0)%></td>
							<td nowrap valign=bottom>&nbsp;&nbsp;&nbsp;&nbsp;</td>
							<td nowrap valign=bottom>
<%
								'Extended Layout
								if listViewLayout = 1 then
									call getFreeShip()
									call getStockLevel()
									call getRatings()
								end if
%>
							</td>
						</tr>
						</table>
					</td>
					<td align=center valign=top><%call getProdImage("center")%></td>
					<td nowrap align=center valign=top width=60>
						<%call getViewButt()%><br>
<%
   if listAction <> "favorites" then 						
						call getAddButt()
   else	
   						call getDeleteButt()

   end if
%>
					</td>
				</tr>
				<tr><td colspan=3><%call getHLine()%></td></tr>
<%
				'Increment record counter & read next record
				count = count + 1
				rstemp.moveNext

			'Check if we must show 2, 3 or 4 Column layouts
			else
			
				'Increment sub counter
				subCount = subCount + 1
				
				'Begin table row
				if subCount = 1 then %>
					<tr>
<%				end if

				'If 2 Columns, show slightly differnt layout
				if listViewLayout = 2 then
%>
					<td align=left valign=top width="<%=cellWidth%>%" class="CPcolsView">
						<%call getProdImage("right")%>
						<%call getprodDesc()%><br><br>
						<%call getprodDescLong()%><br><br>
						<%call getPricing(1)%><br>
						<table border=0 cellpadding=0 cellspacing=0>
						<tr>
							<td align=left valign=top><%call getViewButt()%></td>
							<td align=left valign=top>&nbsp;&nbsp;</td>
							<td align=left valign=top><%call getAddButt()%></td>
							<td align=left valign=top>&nbsp;&nbsp;</td>
<% if listAction = "favorites" then %>
							<td align=left valign=top><%call getDeleteButt()%></td>
<% end if %>
						</tr>
						</table>
					</td>
<%
				else
%>
					<td align=center valign=bottom width="<%=cellWidth%>%" class="CPcolsView">
						<%call getProdImage("center")%><br>
						<%call getprodDesc()%><br>
						<%call getPricing(1)%><br>
						<table border=0 cellpadding=0 cellspacing=0 width="100%">
						<tr>
							<td align=center valign=bottom><%call getViewButt()%></td>
							<td align=center valign=bottom><%call getAddButt()%></td>
<% if listAction = "favorites" then %>
							<td align=center valign=bottom><%call getDeleteButt()%></td>
<% end if %>							

						</tr>
						</table>
					</td>
<%
				end if
				
				'Increment record counter & read next record
				count = count + 1
				rstemp.moveNext

				'End table row
				if subCount >= maxCol or rsTemp.EOF or count >= rstemp.pageSize then
					'Write empty cells if necessary
					do while subCount < maxCol %>
						<td width="<%=cellWidth%>%">&nbsp;</td>
<%						subCount = subCount + 1
					loop
					subCount = 0 %>
					</tr>
<%				end if
				
			end if

		loop
%>
		</table>
		<img src="../UserMods/misc_cleardot.gif" height=4 width=1><br>
<%
		'Show bottom page navigation
		if totalPages > 1 then
%>
			<table width="100%" border="0" cellspacing="0" cellpadding="4" class="CPpageNav">
			<form name="selectPageBotForm">
				<tr><td valign=middle>
					<%call pageNavigation("selectPageBot")%>
				</td></tr>
			</form>
			</table>
<%
		end if
	end if
	call closeRS(rsTemp)
end sub
'*********************************************************************
'Display page navigation
'*********************************************************************
sub pageNavigation(formFieldName)
	Response.Write LangText("GenNavPage","") & " "
	Response.Write "<select onChange=""location.href=this.options[selectedIndex].value"" name=" & trim(formFieldName) & " style=""FONT-SIZE: 8pt"">"
	for I = 1 to TotalPages
		Response.Write "<option value=""prodList.asp?" & queryStr & "&curPage=" & I & "&sortField=" & server.URLEncode(sortField) & """ " & checkMatch(curPage,I) & ">" & I & "</option>" & vbCrlf
	next
	Response.Write "</select> " & LangText("GenOf","") & " " & TotalPages & "&nbsp;&nbsp;"
	Response.Write "[ "
	if curPage > 1 then
		Response.Write "<a href=""prodList.asp?" & queryStr & "&curPage=" & curPage-1 & "&sortField=" & server.URLEncode(sortField) & """>" & LangText("GenNavBack","") & "</a>"
	else
		Response.Write LangText("GenNavBack","")
	end if
	Response.Write " | "
	if curPage < TotalPages then
		Response.Write "<a href=""prodList.asp?" & queryStr & "&curPage=" & curPage+1 & "&sortField=" & server.URLEncode(sortField) & """>" & LangText("GenNavNext","") & "</a>"
	else
		Response.Write LangText("GenNavNext","")
	end if
	Response.Write " ]"
end sub
'*********************************************************************
'Display sort list
'*********************************************************************
sub pageSort(formFieldName)
	Response.Write LangText("GenSort","") & " : "
%>
	<select onChange="location.href=this.options[selectedIndex].value" name="<%=trim(formFieldName)%>" style="FONT-SIZE: 8pt">
		<option value="prodList.asp?<%=queryStr & "&sortField=sortorder"  %>" <%=checkMatch(sortField,"sortorder")  %>><%=LangText("GenDefault","")%></option>
		<option value="prodList.asp?<%=queryStr & "&sortField=description"%>" <%=checkMatch(sortField,"description")%>><%=LangText("GenItemDesc","")%></option>
		<option value="prodList.asp?<%=queryStr & "&sortField=price"	  %>" <%=checkMatch(sortField,"price")      %>><%=LangText("GenPrice","")%></option>
		<option value="prodList.asp?<%=queryStr & "&sortField=sku"        %>" <%=checkMatch(sortField,"sku")        %>><%=LangText("GenSKU","")%></option>
	</select>
<%
end sub
'*********************************************************************
'Display product description
'*********************************************************************
sub getprodDesc()
%>
	<b class="CPprodDesc"><%=addHighlight(Description,searchArr)%></b> 
<%
end sub
'*********************************************************************
'Display product long description
'*********************************************************************
sub getprodDescLong()
%>
	<span class="CPprodDescLong"><%=addHighlight(DescriptionLong,searchArr)%></span>
<%
end sub
'*********************************************************************
'Display product SKU
'*********************************************************************
sub getprodSKU()
%>
	<i class="CPprodSKU">(<%=addHighlight(SKU,searchArr)%>)</i>
<%
end sub
'*********************************************************************
'Display prices
'priceDispType : 0 = Show List, Price, Discount amount
'              : 1 = Show Price Only
'*********************************************************************
sub getPricing(priceDispType)
	if not(pHidePricingZero=-1 and Price=0) then
		if listPrice > Price and priceDispType = 0 then
%>
			<span class=CPprodLPriceT><%=LangText("GenListPrice","")%>:</span> 
			<del  class=CPprodLPriceV><%=moneyS(ListPrice)%></del><br>
<%
		end if
%>
		<b class=CPprodPriceT><%=LangText("GenOurPrice","")%>:</b> 
		<b class=CPprodPriceV><%=moneyS(Price)%></b><br>
<%
		if (listPrice - Price) > 0  and priceDispType = 0 then
%>
			<span class=CPprodSPriceT><%=LangText("GenYouSave","")%>:</span> 
			<span class=CPprodSPriceV><%=moneyS(listPrice-Price)%> (<%=formatNumber((((listPrice-Price)/listPrice)*100),0)%>%)</span><br>
<%
		end if
		if handlingFee > 0 then
%>
		<span class=CPprodPriceT><%=LangText("GenHandlingFee","")%>:</span> 
		<span class=CPprodPriceV><%=moneyS(HandlingFee)%></span><br>
<%
		end if
	end if
end sub
'*********************************************************************
'Display product image
'imgAlign : Images are aligned according to the layout being used
'*********************************************************************
sub getProdImage(imgAlign)
%>
	<table border=0 cellspacing=0 cellpadding=3 align=<%=imgAlign%>>
	<tr><td align=center valign=top>
<%
		if smallImageURL <> "" then
%>
			<a href="prodView.asp?idproduct=<%=IDProduct%>"><img src="<%=pImagesDir & smallImageURL%>" border=0 alt="<%=server.HTMLEncode(description)%>"></a><br>
<%
		else
%>
			<b class=CPnoImgT><%=LangText("GenNoImage","")%></b><br><br>
<%
		end if
%>
	</td></tr>
	</table>
<%
end sub
'*********************************************************************
'Display Free Shipping Message
'*********************************************************************
sub getFreeShip()
	if UCase(noShipCharge) = "Y" and len(fileName) = 0 then
%>
		<b class=CPfreeShipMsg><%=LangText("GenFreeShipping","")%></b><br>
<%
	end if
end sub
'*********************************************************************
'Display Stock Level Message
'*********************************************************************
sub getStockLevel()
	if pShowStockView = -1 then
		if pHideAddStockLevel = -1 then
%>
			<b class=CPinStock><%=LangText("GenInStock","")%></b><br>
<%
		else
			if Stock > pHideAddStockLevel then
%>
				<b class=CPinStock><%=LangText("GenInStock","")%></b><br>
<%
			else
%>
				<b class=CPoutStock><%=LangText("GenOutStock","")%></b><br>
<%
			end if
		end if
	end if
end sub
'*********************************************************************
'Display Ratings
'*********************************************************************
sub getRatings()

	dim mySQL, rsTemp
										
	'Show current ratings
	mySQL="SELECT SUM(revRating)   AS revSum,  " _
		& "       COUNT(revRating) AS revCount " _
		& "FROM   reviews " _
		& "WHERE  idProduct = " & validSQL(idProduct,"I") & " " _
		& "AND    revStatus = 'A' "
	set rsTemp = openRSexecute(mySQL)
	if not rsTemp.EOF then
		if rsTemp("revSum") > 0 and rsTemp("revCount") > 0 then
%>
			<a href="prodReview.asp?idProduct=<%=idProduct%>"><%=LangText("GenAverageRating","")%></a> : <%=ratingImage(rsTemp("revSum")/rsTemp("revCount"))%><br>
<%
		end if
	end if
	call closeRS(rsTemp)
					
end sub
'*********************************************************************
'Get View Add Button
'*********************************************************************
sub getViewButt()
%>
	<a href="<%=urlNonSSL%>prodView.asp?idproduct=<%=IDProduct%>"><img src="../UserMods/butt_view.gif" border="0" vspace=4></a><br>
<%
end sub

'*********************************************************************
'Get Delete Button
'*********************************************************************
sub getDeleteButt()
%>
	<a href="addFav.asp?action=delitem&productid=<%=IDProduct%>"><img src="../UserMods/butt_delete.gif" border="0" vspace=4></a><br>
<%
end sub

'*********************************************************************
'Display Add Button
'*********************************************************************
sub getAddButt()

	dim mySQL, rsTemp
	dim formAction
	
	'Show Add button
	if  pCatalogOnly = 0 _
	and hideAddOnProdList = 0 _
	and (pHideAddStockLevel = -1 or pHideAddStockLevel < CDbl(Stock)) then
						   
		'Check for options and change form "action" attribute
		mySQL = "SELECT idOptionGroup " _
		      & "FROM   optionsGroupsXref " _
		      & "WHERE  idProduct = " & validSQL(idProduct,"I")
		set rsTemp = openRSexecute(mySQL)
		if rsTemp.eof then
			formAction = "cart.asp"
		else
			formAction = "prodView.asp"
		end if
		call closeRS(rsTemp)
%>
		<table border=0 cellspacing=0 cellpadding=0>
		<form method="post" action="<%=urlNonSSL & formAction%>" name="additem">
		<tr><td>
			<input type="hidden" name="action" value="additem">
			<input type="hidden" name="idProduct" value="<%=IDProduct%>">
			<input type="image"  name="add" src="../UserMods/butt_add.gif" border="0" vspace="4"><br>
		</td></tr>
		</form>
		</table>
<%
	end if
	
end sub
'*********************************************************************
'Display horizontal line
'*********************************************************************
sub getHLine()
%>
	<table border=0 cellpadding=0 cellspacing=0 width="100%">
		<tr><td class="CPlines" width="100%">
			<img border="0" height="1" width="1" src="../UserMods/misc_cleardot.gif"><br>
		</td></tr>
	</table>
<%
end sub
'*********************************************************************
'Add highlights to text for search keys
'*********************************************************************
function addHighlight(byVal strIn, keyWords)
	dim keyInd
	if len(trim(strIn)) > 0 and isArray(keyWords) then
		for keyInd = LBound(keyWords) to UBound(keyWords)
			strIn = Replace(strIn, keyWords(keyInd), "*|*" & keyWords(keyInd) & "*||*", 1, -1, 1)
			'strIn = Replace(strIn, keyWords(keyInd), "*|*" & UCase(keyWords(keyInd)) & "*||*", 1, -1, 1)
		next
	end if
	strIn = Replace(strIn, "*|*",  "<SPAN CLASS=CPhighlight>")
	strIn = Replace(strIn, "*||*", "</SPAN>")
	addHighLight = strIn
end function
%>